Index: /LMDZ5/branches/testing/libf/phylmd/physiq.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2056)
@@ -8,6 +8,5 @@
      flxmass_w, &
      d_u, d_v, d_t, d_qx, d_ps &
-     , dudyn &
-     , PVteta)
+     , dudyn)
 
   USE ioipsl, only: histbeg, histvert, histdef, histend, histsync, &
@@ -52,4 +51,8 @@
   USE indice_sol_mod
   USE phytrac_mod, ONLY : phytrac
+
+#ifdef CPP_RRTM
+  USE YOERAD   , ONLY : NRADLP
+#endif
 
   !IM stations CFMIP
@@ -100,6 +103,4 @@
   !! d_qx----output-R-tendance physique de "qx" (kg/kg/s)
   !! d_ps----output-R-tendance physique de la pression au sol
-  !!IM
-  !! PVteta--output-R-vorticite potentielle a des thetas constantes
   !!======================================================================
   include "dimensions.h"
@@ -235,4 +236,5 @@
   ! Variables pour le transport convectif
   real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
+  real wght_cvfd(klon,klev)
   ! Variables pour le lessivage convectif
   ! RomP >>> 
@@ -245,28 +247,5 @@
   !IM definition dynamique o_trac dans phys_output_open
   !      type(ctrl_out) :: o_trac(nqtot)
-  !
-  !IM Amip2 PV a theta constante 
-  !
-  INTEGER nbteta
-  PARAMETER(nbteta=3)
-  CHARACTER*3 ctetaSTD(nbteta)
-  DATA ctetaSTD/'350','380','405'/
-  SAVE ctetaSTD
-  !$OMP THREADPRIVATE(ctetaSTD)
-  REAL rtetaSTD(nbteta)
-  DATA rtetaSTD/350., 380., 405./
-  SAVE rtetaSTD
-  !$OMP THREADPRIVATE(rtetaSTD)     
-  !
-  REAL PVteta(klon,nbteta)
-  !
-  !MI Amip2 PV a theta constante
-
-  !ym      INTEGER klevp1, klevm1
-  !ym      PARAMETER(klevp1=klev+1,klevm1=klev-1)
-  !ym      include "raddim.h"
-  !
-  !
-  !IM Amip2
+
   ! variables a une pression donnee
   !
@@ -510,5 +489,6 @@
   EXTERNAL fisrtilp  ! schema de condensation a grande echelle (pluie)
   !AA 
-  EXTERNAL fisrtilp_tr ! schema de condensation a grande echelle (pluie)
+! JBM (3/14) fisrtilp_tr not loaded
+! EXTERNAL fisrtilp_tr ! schema de condensation a grande echelle (pluie)
   !                          ! stockage des coefficients necessaires au
   !                          ! lessivage OFF-LINE et ON-LINE
@@ -1250,6 +1230,5 @@
      call phys_output_open(rlon,rlat,nCFMIP,tabijGCM, &
           iGCM,jGCM,lonGCM,latGCM, &
-          jjmp1,nlevSTD,clevSTD,rlevSTD, &
-          nbteta, ctetaSTD, dtime,ok_veget, &
+          jjmp1,nlevSTD,clevSTD,rlevSTD, dtime,ok_veget, &
           type_ocean,iflag_pbl,ok_mensuel,ok_journe, &
           ok_hf,ok_instan,ok_LES,ok_ade,ok_aie,  &
@@ -1785,8 +1764,8 @@
      IF (klon_glo==1) THEN
         CALL add_pbl_tend &
-          (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,'vdf')
+          (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,paprs,'vdf')
      ELSE
         CALL add_phys_tend &
-          (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,'vdf')
+          (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,paprs,'vdf')
      ENDIF
      !--------------------------------------------------------------------
@@ -2058,5 +2037,5 @@
              ftd,fqd,lalim_conv,wght_th, &
              ev, ep,epmlmMm,eplaMm, &
-             wdtrainA,wdtrainM)
+             wdtrainA,wdtrainM,wght_cvfd)
         ! RomP <<<
 
@@ -2155,5 +2134,5 @@
   !-----------------------------------------------------------------------------------------
   ! ajout des tendances de la diffusion turbulente
-  CALL add_phys_tend(d_u_con,d_v_con,d_t_con,d_q_con,dql0,'con')
+  CALL add_phys_tend(d_u_con,d_v_con,d_t_con,d_q_con,dql0,paprs,'con')
   !-----------------------------------------------------------------------------------------
 
@@ -2272,5 +2251,5 @@
      d_t_wake(:,:)=dt_wake(:,:)*dtime
      d_q_wake(:,:)=dq_wake(:,:)*dtime
-     CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,'wake')
+     CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,paprs,'wake')
      !-----------------------------------------------------------------------------------------
 
@@ -2372,4 +2351,5 @@
            ENDIF
 
+
            !----Initialisations
            do i=1,klon
@@ -2389,4 +2369,7 @@
                    s_trig,s2,n2
            ENDIF
+ 
+!Option pour re-activer l'ancien calcul de Ale_bl (iflag_trig_bl=2)
+           IF (iflag_trig_bl.eq.1) then
 
            !----Tirage al\'eatoire et calcul de ale_bl_trig
@@ -2407,4 +2390,26 @@
               endif
            enddo
+
+           ELSE IF (iflag_trig_bl.eq.2) then
+
+           do i=1,klon
+              if ( (Ale_bl(i) .gt. abs(cin(i))+1.e-10) )  then
+                 proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
+                      (n2(i)*dtime/tau_trig(i))
+                 !        print *, 'proba_notrig(i) ',proba_notrig(i)
+                 if (random_notrig(i) .ge. proba_notrig(i)) then 
+                    ale_bl_trig(i)=Ale_bl(i)
+                 else
+                    ale_bl_trig(i)=0.
+                 endif
+              else
+                 proba_notrig(i)=1.
+                 random_notrig(i)=0.
+                 ale_bl_trig(i)=0.
+              endif
+           enddo
+
+           ENDIF
+
            !
            IF (prt_level .GE. 10) THEN
@@ -2416,6 +2421,16 @@
 
         !-----------Statistical closure-----------
-        if (iflag_clos_bl.ge.1) then 
-
+        if (iflag_clos_bl.eq.1) then 
+
+           do i=1,klon
+!CR: alp probabiliste
+               if (ale_bl_trig(i).gt.0.) then
+                  alp_bl(i)=alp_bl(i)/(1.-min(proba_notrig(i),0.999))
+               endif
+           enddo        
+  
+        else if (iflag_clos_bl.eq.2) then
+
+!CR: alp calculee dans thermcell_main
            do i=1,klon
               alp_bl(i)=alp_bl_stat(i)
@@ -2454,5 +2469,7 @@
 
         do i=1,klon
-           zmax_th(i)=pphi(i,lmax_th(i))/rg
+!           zmax_th(i)=pphi(i,lmax_th(i))/rg
+!CR:04/05/12:correction calcul zmax
+         zmax_th(i)=zmax0(i) 
         enddo
 
@@ -2494,5 +2511,5 @@
         !-----------------------------------------------------------------------------------------
         ! ajout des tendances de l'ajustement sec ou des thermiques
-        CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,'ajsb')
+        CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,paprs,'ajsb')
         d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_ajsb(:,:)
         d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_ajsb(:,:)
@@ -2552,5 +2569,5 @@
   !-----------------------------------------------------------------------------------------
   ! ajout des tendances de la diffusion turbulente
-  CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,'lsc')
+  CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,paprs,'lsc')
   !-----------------------------------------------------------------------------------------
   DO k = 1, klev
@@ -2659,5 +2676,7 @@
      !jq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
      IF (flag_aerosol .gt. 0) THEN
-        IF (.NOT. aerosol_couple) &
+        IF (.NOT. aerosol_couple) THEN
+           IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+!
              CALL readaerosol_optic( &
              debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
@@ -2666,9 +2685,33 @@
              tau_aero, piz_aero, cg_aero,  &
              tausum_aero, tau3d_aero)
+!
+           ELSE                       ! RRTM radiation
+!
+#ifdef CPP_RRTM
+             CALL readaerosol_optic_rrtm( &
+             debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+             pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+             mass_solu_aero, mass_solu_aero_pi,  &
+             tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,  &
+             tausum_aero, tau3d_aero)
+#else
+
+            abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
+            call abort_gcm(modname,abort_message,1)
+#endif
+!
+           ENDIF
+        ENDIF
      ELSE
         tausum_aero(:,:,:) = 0.
-        tau_aero(:,:,:,:) = 0.
-        piz_aero(:,:,:,:) = 0.
-        cg_aero(:,:,:,:)  = 0.
+        IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+          tau_aero(:,:,:,:) = 0.
+          piz_aero(:,:,:,:) = 0.
+          cg_aero(:,:,:,:)  = 0.
+        ELSE
+          tau_aero_rrtm(:,:,:,:)=0.0
+          piz_aero_rrtm(:,:,:,:)=0.0
+          cg_aero_rrtm(:,:,:,:)=0.0
+        ENDIF
      ENDIF
      !
@@ -2677,5 +2720,15 @@
      IF (flag_aerosol_strat) THEN
         PRINT *,'appel a readaerosolstrat', mth_cur
-        CALL readaerosolstrato(debut)
+        IF (iflag_rrtm.EQ.0) THEN
+         CALL readaerosolstrato(debut)
+        ELSE
+#ifdef CPP_RRTM
+         CALL readaerosolstrato_rrtm(debut)
+#else
+
+         abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
+         call abort_gcm(modname,abort_message,1)
+#endif
+        ENDIF
      ENDIF
      !--fin STRAT AEROSOL
@@ -2896,4 +2949,16 @@
 
   if (ok_newmicro) then
+     IF (iflag_rrtm.NE.0) THEN 
+#ifdef CPP_RRTM
+       IF (ok_cdnc.AND.NRADLP.NE.3) THEN
+         abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 pour ok_cdnc' 
+         call abort_gcm(modname,abort_message,1)
+       endif
+#else
+
+       abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
+       call abort_gcm(modname,abort_message,1)
+#endif
+     ENDIF
      CALL newmicro (ok_cdnc, bl95_b0, bl95_b1, &
           paprs, pplay, t_seri, cldliq, cldfra, &
@@ -3037,4 +3102,5 @@
              flag_aerosol_strat, &
              tau_aero, piz_aero, cg_aero, &
+             tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,&     ! Rajoute par OB pour RRTM
              cldtaupirad,new_aod, &
              zqsat, flwc, fiwc, &
@@ -3083,4 +3149,5 @@
                    flag_aerosol_strat, &
                    tau_aero, piz_aero, cg_aero, &
+                   tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,&     ! Rajoute par OB pour RRTM
                    cldtaupi,new_aod, &
                    zqsat, flwc, fiwc, &
@@ -3220,5 +3287,5 @@
      !-----------------------------------------------------------------------------------------
      ! ajout des tendances de la trainee de l'orographie
-     CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,'oro')
+     CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,paprs,'oro')
      !-----------------------------------------------------------------------------------------
      !
@@ -3266,5 +3333,5 @@
      !-----------------------------------------------------------------------------------------
      ! ajout des tendances de la portance de l'orographie
-     CALL add_phys_tend(d_u_lif,d_v_lif,d_t_lif,dq0,dql0,'lif')
+     CALL add_phys_tend(d_u_lif,d_v_lif,d_t_lif,dq0,dql0,paprs,'lif')
      !-----------------------------------------------------------------------------------------
      !
@@ -3280,5 +3347,5 @@
      !
      !  ajout des tendances
-     CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,'hin')
+     CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,paprs,'hin')
 
   ENDIF
@@ -3288,5 +3355,5 @@
           rain_fall + snow_fall, zustr_gwd_rando, zvstr_gwd_rando, &
           du_gwd_rando, dv_gwd_rando)
-     CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, &
+     CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0,paprs, &
           'flott_gwd_rando')
   end if
@@ -3408,5 +3475,5 @@
        pmflxr,   pmflxs,    prfl,     psfl, &
        da,       phi,       mp,       upwd, &
-       phi2,     d1a,       dam,      sij, &        !<<RomP
+       phi2,     d1a,       dam,      sij, wght_cvfd, &        !<<RomP+RL
        wdtrainA, wdtrainM,  sigd,     clw,elij, &   !<<RomP
        ev,       ep,        epmlmMm,  eplaMm, &     !<<RomP
@@ -3708,5 +3775,5 @@
        ptconv, read_climoz, clevSTD,                   &
        ptconvth, d_t, qx, d_qx, zmasse,                &
-       flag_aerosol_strat)
+       flag_aerosol, flag_aerosol_strat, ok_cdnc)
 
 
Index: /LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2056)
@@ -54,27 +54,27 @@
 CONTAINS
 
-SUBROUTINE phytrac(                            &
-     nstep,     julien,   gmtime,   debutphy,  &
-     lafin,     pdtphys,  u, v,     t_seri,    &
-     paprs,     pplay,    pmfu,     pmfd,      &
-     pen_u,     pde_u,    pen_d,    pde_d,     &
-     cdragh,    coefh,    fm_therm, entr_therm,&
-     yu1,       yv1,      ftsol,    pctsrf,    &
-     ustar,     u10m,      v10m,               &
-     wstar,     ale_bl,      ale_wake,         &
-     xlat,      xlon,                          &
-     frac_impa,frac_nucl,beta_fisrt,beta_v1,   &
-     presnivs,  pphis,    pphi,     albsol,    &
-     sh,        rh,       cldfra,   rneb,      &
-     diafra,    cldliq,   itop_con, ibas_con,  &
-     pmflxr,    pmflxs,   prfl,     psfl,      &
-     da,        phi,      mp,       upwd,      &
-     phi2,      d1a,      dam,      sij,       &   ! RomP
-     wdtrainA,  wdtrainM, sigd,     clw,elij,  &   ! RomP 
-     evap,      ep,       epmlmMm,  eplaMm,    &   ! RomP
-     dnwd,      aerosol_couple,     flxmass_w, &
-     tau_aero,  piz_aero,  cg_aero, ccm,       &
-     rfname,                                   &
-     d_tr_dyn,                                 &   ! RomP
+SUBROUTINE phytrac(                                 &
+     nstep,     julien,   gmtime,   debutphy,       &
+     lafin,     pdtphys,  u, v,     t_seri,         &
+     paprs,     pplay,    pmfu,     pmfd,           &
+     pen_u,     pde_u,    pen_d,    pde_d,          &
+     cdragh,    coefh,    fm_therm, entr_therm,     &
+     yu1,       yv1,      ftsol,    pctsrf,         &
+     ustar,     u10m,      v10m,                    &
+     wstar,     ale_bl,      ale_wake,              &
+     xlat,      xlon,                               &
+     frac_impa,frac_nucl,beta_fisrt,beta_v1,        &
+     presnivs,  pphis,    pphi,     albsol,         &
+     sh,        rh,       cldfra,   rneb,           &
+     diafra,    cldliq,   itop_con, ibas_con,       &
+     pmflxr,    pmflxs,   prfl,     psfl,           &
+     da,        phi,      mp,       upwd,           &
+     phi2,      d1a,      dam,      sij, wght_cvfd, &   ! RomP +RL
+     wdtrainA,  wdtrainM, sigd,     clw, elij,      &   ! RomP 
+     evap,      ep,       epmlmMm,  eplaMm,         &   ! RomP
+     dnwd,      aerosol_couple,     flxmass_w,      &
+     tau_aero,  piz_aero,  cg_aero, ccm,            &
+     rfname,                                        &
+     d_tr_dyn,                                      &   ! RomP
      tr_seri)         
 !
@@ -190,4 +190,5 @@
   REAL,DIMENSION(klon,klev),INTENT(IN)      :: ep
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: sij
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd          !RL
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: elij
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: epmlmMm
@@ -507,5 +508,6 @@
 !
           CALL cvltr(pdtphys, da, phi,phi2,d1a,dam, mp,ep,              &
-               sigd,sij,clw,elij,epmlmMm,eplaMm,                        &
+!!               sigd,sij,clw,elij,epmlmMm,eplaMm,                        &   !RL
+               sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,              &     !RL
                pmflxr,pmflxs,evap,t_seri,wdtrainA,wdtrainM,             &   
                paprs,it,tr_seri,upwd,dnwd,itop_con,ibas_con,            &
@@ -514,6 +516,8 @@
                zmfd1a,zmfphi2,zmfdam)
         else  !pas de lessivage convectif ou n'est pas un aerosol
-           CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tr_seri,&
-                    upwd,dnwd,d_tr_cv)
+!!           CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tr_seri,&      !jyg
+!!                    upwd,dnwd,d_tr_cv)                                      !jyg
+           CALL cvltr_noscav(it,pdtphys, da, phi,mp,wght_cvfd,paprs,pplay, &  !jyg
+                    tr_seri,upwd,dnwd,d_tr_cv)                                !jyg
         endif
         END IF
